=== debian/changelog ===
looking-glass (0+b5.0.1-2) unstable; urgency=medium

  * Added new binary package obs-plugin-looking-glass
  * Fix broken build
    * Added xpresenter build dependency
  * Fixed file watch
    * Updated watch file

 -- Lennart Weller <lhw@ring0.de>  Sun, 20 Mar 2022 15:57:12 +0100

looking-glass (0+b5.0.1-1) unstable; urgency=medium

  * New upstream release

 -- Lennart Weller <lhw@ring0.de>  Thu, 17 Mar 2022 23:56:45 +0100
