=== debian/watch ===
version=4
opts=uversionmangle=s/(a|B)(\d\S*)/\L$1$2/,dversionmangle=s/(0\+|\+dfsg\.\d)//,filenamemangle=s/(a|B)(\d\S*)\.tar\.gz/looking-glass-$1$2\.tar\.gz/ \
  https://looking-glass.io/downloads \
  artifact/([a|B][\d\.]+)/source
