=== debian/changelog ===
looking-glass (0+b6-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 17:51:18 +1100

looking-glass (0+b6-1build1) noble; urgency=medium

  * No-change rebuild against libhogweed6t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 03 Mar 2024 06:23:54 +0000

looking-glass (0+b6-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster (oldstable):
    + Build-Depends: Drop versioned constraint on dh-exec (>= 0.3).

  [ James Lu ]
  * New upstream release. (Closes: #1005061)
    - Add support for routing audio via SPICE
  * Packaging changes:
    - Add myself to uploaders.
    - Add B-D: libpipewire-0.3-dev, libpulse-dev, libsamplerate0-dev
    - Update B-D libfontconfig1-dev -> libfontconfig-dev
    - Update debian/watch for new source tarball download paths
    - Add 0002-CheckSubmodule.cmake-Check-for-.gitmodules-in-additi.patch:
      Disable check for unresolved submodules unless .gitmodules is present in
      the source tree
    - Bump to Standards-Version 4.6.2 (no changes needed)
    - Update to debhelper 13
    - Adjust paths in debian/*.install

 -- James Lu <jlu@debian.org>  Fri, 30 Jun 2023 17:37:17 -0700
